<?php

namespace Relawan\Program\Http\Controllers;

use App\Http\Controllers\PublicController as CMSPublicController;
use Relawan\Program\Interfaces\ProgramRepositoryInterface;

class ProgramPublicController extends CMSPublicController
{
    /**
     * Constructor.
     *
     * @param type \Relawan\Program\Interfaces\ProgramRepositoryInterface $program
     *
     * @return type
     */
    public function __construct(ProgramRepositoryInterface $program)
    {
        $this->model = $program;
        parent::__construct();
    }

    /**
     * Show program's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $programs = $this->model->all();

        return $this->theme->of('program::public.program.index', compact('programs'))->render();
    }

    /**
     * Show program.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $program = $this->model->findBySlug($slug);

        return $this->theme->of('program::public.program.show', compact('program'))->render();
    }
}
